<?php

/*
Plugin Name: Net Passport Woo Exporter
Plugin URI: http://URI_Of_Page_Describing_Plugin_and_Updates
Description: A brief description of the Plugin.
Version: 1.0
Author: tht7
Author URI: http://URI_Of_The_Plugin_Author
License: A "Slug" license name e.g. GPL2
*/
if ( is_readable( plugin_dir_path( __FILE__ ) . '/vendor/autoload.php' ) ) {
    require plugin_dir_path( __FILE__ ) . 'vendor/autoload.php';;
}
define('BASE_PATH', plugin_dir_path(__FILE__));
define('BASE_URL', plugin_dir_url(__FILE__));
// include the classes

use NetPassport\Signer;
use Lcobucci\JWT\Signer\Key\InMemory;

function net_passport_woo_exporter_activate() {}
function net_passport_options_validate( $input ) {
    return $input;
}

function net_passport_register_settings() {
    register_setting( 'net_passport_options', 'net_passport_options', 'net_passport_options_validate' );
    add_settings_section( 'api_settings', 'Keys Settings', 'net_passport_plugin_section_text', 'net_passport' );

    add_settings_field( 'net_passport_setting_id', 'NetPassport ID', 'net_passport_setting_id', 'net_passport', 'api_settings' );
    add_settings_field( 'net_passport_setting_key', 'Private Key', 'net_passport_setting_key', 'net_passport', 'api_settings' );
}
add_action( 'admin_init', 'net_passport_register_settings' );

function net_passport_add_settings_page() {
    add_options_page( 'Net passport signer', 'Net passport signer', 'manage_options', 'net_passport', 'net_passport_render_plugin_settings_page' );
}
add_action( 'admin_menu', 'net_passport_add_settings_page' );


function net_passport_render_plugin_settings_page() {
    ?>
    <h2>Example Plugin Settings</h2>
    <form action="options.php" method="post">
        <?php
        settings_fields( 'net_passport_options' );
        do_settings_sections( 'net_passport' ); ?>
        <input name="submit" class="button button-primary" type="submit" value="<?php esc_attr_e( 'Save' ); ?>" />
    </form>
    <?php
}

function net_passport_setting_key() {
    $options = get_option( 'net_passport_options' );
    echo "<textarea id='net_passport_setting_key' name='net_passport_options[net_passport_setting_key]' >" . esc_attr( $options['net_passport_setting_key'] ) . "</textarea>";
}

function net_passport_setting_id() {
    $options = get_option( 'net_passport_options' );
    echo "<input id='net_passport_setting_id' name='net_passport_options[net_passport_setting_id]' type='text' value='" . esc_attr( $options['net_passport_setting_id'] ) . "' />";
}
register_activation_hook( __FILE__, 'net_passport_woo_exporter_activate' );

add_filter('net-passport-id', function () {
    $options = get_option( 'net_passport_options' );
    return $options['net_passport_setting_id'];
}, 10, 0)

add_filter('net-passport-sign', function ($value) {
    $options = get_option( 'net_passport_options' );
    $privateKey = InMemory::plainText($options['net_passport_setting_key']);
    $signature = Signer::signObject($value, $privateKey);
    return $signature;
}, 10, 1);
